{=======================================================================================================================

  What's New Make.

     .

========================================================================================================================

  :

  28.03.2019 [*]   .
             [*]    .
             [+]    . .
  07.02.2018 [*]    HTML-.
  20.12.2016 [+]    .
  23.02.2012 [+]  .
             [!] Delphi XE2
  21.03.2005 [*]      .
             [*]       .
  24.03.2004 [*]       .
             [*]     .
  23.03.2004 [+]     .
             [+]   .
  22.03.2004 [+]  .
  22.03.2004 [!]  .

========================================================================================================================
  Copyright 20042019 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgAnalisis.pas,v 1.9 2019/03/28 08:47:20 tsk Exp $
=======================================================================================================================}
unit dgAnalisis;

interface

uses  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, ComCtrls, PropStorageEh,
      PropFilerEh, StrUtils,
      // Comming:
      CommingOther;

type
  TAnalisisDG = class(TForm)
    btRun: TButton;
    gbOption: TGroupBox;
    pbDo: TProgressBar;
    psAnalisis: TPropStorageEh;
    edDate: TDateTimePicker;
    Label1: TLabel;
    rbAll: TRadioButton;
    rbOnlyChange: TRadioButton;
    cbNote: TCheckBox;
    laFile: TStaticText;
    cbHTML: TCheckBox;
    Label2: TLabel;
    edDateEnd: TDateTimePicker;
    cbLine: TCheckBox;
    edLine: TEdit;
    Label3: TLabel;
    procedure btRunClick(Sender: TObject);
  private   { Private declarations }
    FFile: TStringList;
  public    { Public declarations }
    ResultText: TStringList;
    function  Run( Files: TStringList ): Integer;
  end;

var AnalisisDG: TAnalisisDG;

implementation

uses fmMain;
{$R *.dfm}
//======================================================================================================================
{ TAnalisisDG }
//======================================================================================================================
function TAnalisisDG.Run( Files: TStringList ): Integer;
begin
  FFile             := Files;
  ResultText        := TStringList.Create;
  pbDo.Max          := FFile.Count;
  pbDo.Position     := 0;
  laFile.Caption    := '...';
  gbOption.Enabled  := True;
  btRun.Enabled     := True;
//  edDateEnd.Date    := Now();
  Result            := ShowModal;
end;
//======================================================================================================================
procedure TAnalisisDG.btRunClick( Sender: TObject );
  var Module: TStringList;
      i, j, p: Integer;
      FN, N, Tx, Er, ErFN: String;
      D, DMin, DMax: TDate;
  procedure AddLine( Line: String );
  begin
    Tx := Tx + iif( Tx <> EmptyStr, #13#10, '') + Line;
  end;
  procedure AddError( Line: String );
  begin
    if ErFN <> FN then begin
      Er := Er + iif( Er <> EmptyStr, #13#10#13#10, '' ) + FN;
      ErFN := FN
    end;
    Er := Er + #13#10 + Line;
  end;
begin
  if edDate.Date >= edDateEnd.Date then edDate.Date := edDateEnd.Date;
  Screen.Cursor     := crHourGlass;
  gbOption.Enabled  := False;
  btRun.Enabled     := False;
  Module            := TStringList.Create;
  ResultText.Text   := DateToStr( edDate.Date ) + ' - ' + DateToStr( edDateEnd.Date );
  for i := 0 to FFile.Count - 1 do begin
    //  :
    FN := ExtractFileName( FFile[i] );
    N := '';
    laFile.Caption := FN;
    Module.LoadFromFile( FFile[i] );
    if ( Copy( Module[0], 1, 3 ) = '{==' ){ or ( Copy( Module[0], 1, 3 ) = '/*=' )} then begin
      // :
      j := 4;
      if Copy(Module[j], 1, 2) <> '==' then begin
        N := Trim( Module[j] ); Inc( j );
        while not Empty( Module[j] ) do begin
          N := N + #13#10 + Trim(Module[j]); Inc( j );
        end;
      end;
      //  :
      Tx := '';
      while ( j < Module.Count ) and ( Pos( ':', Module[j] ) = 0 ) do Inc( j );
      if ( j >= Module.Count ) then begin
        N := '';
        AddLine( ':   .' );
      end else begin
        Inc( j, 2 );
        // :
//        T := '';
//        AddLine( '' );
//        AddLine( '' );
        if not Empty( Trim( Copy( Module[j], 3, 10 ))) then begin
          try
            D := StrToDate( Copy( Module[j], 3, 10 ));
          except
            D := Date;
            AddError( Format( ':    %d]', [ j ]));
          end;
          DMax := D; DMin := D;
          while ( D >= edDate.Date ) and ( D<= edDateEnd.Date ) do begin
            p := Pos ( '[' , Module[j] );
            if p > 0 then
              if cbHTML.Checked
                then AddLine( '<p>' + Copy( Module[j], p, Length(Module[j]) - p + 1 ) + '</p>' )
                else AddLine( Copy( Module[j], p, Length(Module[j]) - p + 1 ));
            Inc( j );
            if ( Copy(Module[j], 1, 1) = '=' ) then Break;
            if not Empty( Trim( Copy( Module[j], 3, 10 ))) then D := StrToDateDef( Copy( Module[j], 3, 10 ), D );
            if D < DMin then DMin := D;
//            T := DateToStr( DMin ) + T;
          end;
          //  :
          while ( j < Module.Count ) do begin
            Inc( j );
            if Pos( 'CVS: $Id:', Module[j] ) > 0 then Break;
            if Pos( 'Copyright', Module[j] ) > 0  then begin
//              T := T + #13#10 + Copy( Module[j], 13, 4 );
              if Copy( Module[j], 13, 4 ) <> FormatDateTime( 'yyyy', DMin )
                then AddError( Format( '  Copyright:    %s.', [ FormatDateTime( 'yyyy', DMin ) ]));
              if ( Copy( Module[j], 17, 1 ) = '' ) and ( Copy( Module[j], 18, 4 ) <> FormatDateTime( 'yyyy', DMax ))
                then AddError( Format( '  Copyright:     %s.', [ FormatDateTime( 'yyyy', DMax )]));
            end;
            if not Empty( Trim( Copy( Module[j], 3, 10 ))) then D := StrToDateDef( Copy( Module[j], 3, 10 ), D );
            if D < DMin then DMin := D;
          end;
        end;
      end;
      if ( rbOnlyChange.Checked ) and ( not Empty( Tx )) then begin
        if cbHTML.Checked
            then ResultText.Add( #13#10 + '<h3 class="filename">'+ FN + '</h3>')
            else ResultText.Add( #13#10 + FN );
        if cbNote.Checked and ( N <> EmptyStr ) then
          if cbHTML.Checked
            then ResultText.Add( '<p class="filedescrip">' + N + '</p>' )
            else ResultText.Add( N );
        ResultText.Add( Tx );
      end else if not ( rbOnlyChange.Checked ) then begin
        if cbHTML.Checked
            then ResultText.Add( #13#10 + '<h3 class="filename">'+ FN + '</h3>')
            else ResultText.Add( #13#10 + FN );
        if cbNote.Checked and ( N <> EmptyStr ) then
          if cbHTML.Checked
            then ResultText.Add( '<p class="filedescrip">' + N + '</p>' )
            else ResultText.Add( N );
        if Tx <> EmptyStr then ResultText.Add( Tx );
      end;
    end else begin
      AddError( ':  .');
    end;
    pbDo.StepIt;
  end;
  if Er <> EmptyStr then ResultText.Text := Er;
  Module.Free;
  btRun.Enabled     := True;
  gbOption.Enabled  := True;
  Screen.Cursor     := crDefault;
end;
//======================================================================================================================
end.
