{=======================================================================================================================

  What's New Make.

         .

========================================================================================================================

  :

  09.01.2018 [*]   .
  05.03.2017 [*]     .
  20.12.2016 [+]       .
             [*]      TComboBox.
  07.01.2016 [+]     .
  23.02.2012 [+] cbSource:  .
             [!] Delphi XE2
  22.03.2004 [+]  .
  22.03.2004 [!]  .

========================================================================================================================
  Copyright 20042018 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmMain.pas,v 1.10 2018/01/09 07:16:20 tsk Exp $
=======================================================================================================================}
unit fmMain;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls,
      PropStorageEh, ComCtrls, ToolWin, ActnList, ImgList, PropFilerEh, System.Actions, System.ImageList,
      // Comming:
      CommingFile, CommingVersionInfo;

type
  TMainFM = class(TForm)
    lbFile: TListBox;
    meResult: TMemo;
    spResult: TSplitter;
    psFile: TPropStorageEh;
    reMain: TRegPropStorageManEh;
    tbMain: TToolBar;
    ToolButton1: TToolButton;
    alMain: TActionList;
    acFiles: TAction;
    imTool: TImageList;
    acAnalisis: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    dgSave: TSaveDialog;
    acSave: TAction;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    cbSource: TComboBox;
    dgOpen: TOpenDialog;
    procedure acFilesExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acAnalisisUpdate(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure acAnalisisExecute(Sender: TObject);
    procedure acSaveUpdate(Sender: TObject);
    procedure psFileAfterLoadProps(Sender: TObject);
    procedure cbSourceChange(Sender: TObject);
  private   { Private declarations }
    FPoject: String;
    procedure ReadFile;
  public    { Public declarations }
  end;

var MainFM: TMainFM;

implementation

uses dgAnalisis;

{$R *.dfm}
//======================================================================================================================
{ TMainFM }
//======================================================================================================================
procedure TMainFM.FormCreate(Sender: TObject);
begin
  meResult.Text := GetVersion;
end;
//======================================================================================================================
procedure TMainFM.psFileAfterLoadProps(Sender: TObject);
  var i: Integer;
begin
  i := 0;
  while ( i < cbSource.Items.Count ) do begin
    if not DirectoryExists( cbSource.Items[i] ) then begin
      cbSource.Items.Delete( i );
      i := 0;
      cbSource.ItemIndex := 0;
    end;
    Inc( i );
  end;
end;
//======================================================================================================================
procedure TMainFM.ReadFile;
  var FileList: TStringList;
begin
  FileList := TStringList.Create;
  FileList.Clear;
  Screen.Cursor := crHourGlass;
  RecurseDir( cbSource.Text, 'pas', FileList );
  RecurseDir( cbSource.Text, 'sql', FileList );
  RecurseDir( cbSource.Text, 'dpr', FileList );
  RecurseDir( cbSource.Text, 'dpk', FileList );
  lbFile.Items.Assign( FileList );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TMainFM.cbSourceChange(Sender: TObject);
begin
  lbFile.Clear;
  meResult.Clear;
end;
//======================================================================================================================
// Files:
procedure TMainFM.acFilesExecute(Sender: TObject);
begin
  dgOpen.InitialDir := cbSource.Text;
  if dgOpen.Execute then begin
    cbSource.Text := ExtractFilePath( dgOpen.FileName );
    lbFile.Clear;
    meResult.Clear;
    ReadFile;
  end;
end;
//======================================================================================================================
// Analisis:
procedure TMainFM.acAnalisisUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := DirectoryExists( cbSource.Text );
end;
//======================================================================================================================
procedure TMainFM.acAnalisisExecute(Sender: TObject);
begin
  if (lbFile.Items.Count = 0) then ReadFile;
  if (lbFile.Items.Count > 0) then begin
    meResult.Clear;
    FPoject := ExtractDirectoryName( cbSource.Text );
    AnalisisDG.psAnalisis.Section := 'Analisis\' + FPoject;
    AnalisisDG.psAnalisis.LoadProperties;
    if ( AnalisisDG.Run( TStringList( lbFile.Items )) = mrOK ) and ( AnalisisDG.ResultText.Count > 0 )
      then meResult.Lines.Text := AnalisisDG.ResultText.Text;
    if AnalisisDG.cbLine.Checked and ( meResult.Lines.Count > StrToIntDef( AnalisisDG.edLine.Text, 0 )) then begin
      AnalisisDG.edDate.Date := ( AnalisisDG.edDateEnd.Date - 1 );
      meResult.Lines.Clear;
      while ( meResult.Lines.Count < StrToIntDef( AnalisisDG.edLine.Text, 0 ))
                                                    and ( Pos( ' ', meResult.Lines.Text ) = 0 ) do begin
        AnalisisDG.edDate.Date := ( AnalisisDG.edDate.Date - 1 );
        AnalisisDG.btRunClick( AnalisisDG );
        meResult.Lines.Text := AnalisisDG.ResultText.Text;
//        meResult.Lines.Insert( 0, IntToStr( meResult.Lines.Count ) + ' : ' + IntToStr( AnalisisDG.ResultText.Count) );
      end;
    end;
    AnalisisDG.psAnalisis.SaveProperties;
//    ShowMessage( IntToStr ( meResult.Lines.Count ));
  end;
end;
//======================================================================================================================
// Save:
procedure TMainFM.acSaveUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (meResult.Lines.Count > 0);
end;
//======================================================================================================================
procedure TMainFM.acSaveExecute(Sender: TObject);
begin
  dgSave.InitialDir := cbSource.Text;
  dgSave.FileName   := FPoject + '.change.';
  if AnalisisDG.cbHTML.Checked
    then dgSave.FileName := dgSave.FileName + 'htm'
    else dgSave.FileName := dgSave.FileName + 'txt';
  if dgSave.Execute then begin
    meResult.Lines.SaveToFile( dgSave.FileName );
    if cbSource.Items.IndexOf( cbSource.Text ) < 0 then cbSource.Items.Add( cbSource.Text );
  end;
end;
//======================================================================================================================
end.
